#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include <ctype.h>
#include <string.h>
#include <fstream.h>

enum bool { false, true };

long caseNo = 0;

bool finish = false;
long N, M;
const long MAX = 101;
char mat[MAX][MAX];
char used[MAX];
struct Path{
	long num;
	long data[MAX];
	void operator += (long n){
		data[num++] = n;
	}
} path1, path2;

void Input(){
	memset(mat, 0, sizeof mat);
	cin >> N >> M;
	for (long i = M - 1; i >= 0; i--){
		long n, m;
		cin >> n >> m;
		mat[n - 1][m - 1] = 1;
		mat[m - 1][n - 1] = 1;
	}
}

bool DFSA(long n, long k){
	if (n == 0)
		return true;
	used[n] = 1;
	for (long j = 0; j < 2 * N; j++){
		long i = random(N);
		if (!used[i] && mat[n][i])
			if (DFSA(i, k + 1)){
				path2 += n;
				return true;
			}
	}
	used[n] = 0;
	return false;
}

bool DFSB(long n, long k){
	used[n] = 1;
	if (n == N - 1){
		used[0] = 0;
		if (DFSA(N - 1, 0)){
			used[0] = 1;
			return true;
		}
		used[0] = 1;
		return false;
	}
	for (long j = 0; j < 2 * N; j++){
		long i = random(N);
		if (!used[i] && mat[n][i])
			if(DFSB(i, k + 1)){
				path1 += n;
				return true;
			}
	}
	used[n] = 0;
	return false;
}

void Solve(){
	DFSB(0, 0);
}

void Output(){
	cout << path1.num;
	for (long i = path1.num - 1; i >= 0; i--)
		cout << ' ' << path1.data[i] + 1;
	cout << ' ' << N << endl;
	cout << path2.num;
	cout << ' ' << 1;
	for (long j = 0; j < path2.num; j++)
		cout << ' ' << path2.data[j] + 1;
	cout << endl;
}

int main()
{
	randomize();
	ifstream is = "input.txt";
	ofstream os = "output.txt";
	cin = is;
	cout = os;
		Input();
		Solve();
		Output();
	return 0;
}